"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
const LazyLoadImage = _ref => {
  let {
    src,
    alt,
    placeholderColor = '#e0e0e0',
    ...props
  } = _ref;
  const [isVisible, setIsVisible] = (0, _react.useState)(false);
  const imgRef = (0, _react.useRef)(null);
  (0, _react.useEffect)(() => {
    const observer = new IntersectionObserver(entries => {
      entries.forEach(entry => {
        if (entry.isIntersecting) {
          setIsVisible(true);
          observer.disconnect();
        }
      });
    }, {
      root: null,
      rootMargin: '0px',
      threshold: 0.1
    });
    const currentImgRef = imgRef.current;
    if (currentImgRef) {
      observer.observe(currentImgRef);
    }
    return () => {
      if (currentImgRef) {
        observer.unobserve(currentImgRef);
      }
    };
  }, []);
  return /*#__PURE__*/_react.default.createElement("div", {
    style: {
      backgroundColor: !isVisible ? placeholderColor : 'transparent',
      transition: 'background-color 0.5s ease-in-out',
      width: props.width,
      height: props.height,
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center',
      overflow: 'hidden',
      borderRadius: '8px'
    }
  }, /*#__PURE__*/_react.default.createElement("img", _extends({
    ref: imgRef,
    src: isVisible ? src : '',
    alt: alt
  }, props, {
    style: {
      opacity: isVisible ? 1 : 0,
      transition: 'opacity 0.5s ease-in-out',
      width: '100%',
      height: '100%',
      objectFit: 'cover'
    }
  })));
};
var _default = exports.default = LazyLoadImage;